from multiprocessing import Process
 
class NullSink(Process):
       
	def __init__(self, config, rpipe, logger):
		logger.debug("%s processor initalized", self.__class__)
	       
		#Needed to initalize the process
		super(self.__class__, self).__init__()
	       
		# Exit if the parent does
		self.daemon=True
	       
		#store for later
		self.config = config
		self.readPipe = rpipe
		self.logger = logger
	       
	def run(self):
		"""This is the thread that takes care of actually managing the hardware and returning read data points"""
		self.logger.info("Started")
		
	from time import sleep
	sleep(2)

	while True:
		try:
			self.logger.debug("Recieved: %s", self.readPipe.recv())
		except (EOFError):
			self.logger.info("Recieved EOF Error")
			break
 
	def start(self):
		"""This overloading is done in order to clean up references in this thread to pipes.  Leaving these around results in calls to recv() never returning EOFError, which makes using them rather hard."""
		super(self.__class__, self).start()
		self.readPipe.close()
	       
def __init__(config, readp, writep, logger):
	return NullSink(config, readp, logger)
       
	       
###
# Begin unit testing hooks
###
import unittest
class TestProcessor(unittest.TestCase):
	def setUp(self):
		"""Set up for all of the tests.  In this case, we create and store a NullSink object"""
		from multiprocessing import Pipe
		from logging import getLogger
		inputReadPipe, self.inputWritePipe = Pipe(False)
	       
		self.processor = NullSink(None, inputReadPipe, getLogger())
		self.processor.start()
		inputReadPipe.close()
       
	def test_closedEndPipe(self):
		self.inputWritePipe.close()
		self.processor.join()
		
		       
 
if __name__=="__main__":
	unittest.main()
